forum/urls.py
from django.urls import path

from . import views

app_name = 'forum'

urlpatterns = [
    path('', views.forum, name='forum1'),
    path('category/<str:category>/', views.forum, name='forum2'),
    path('addPost/', views.editPost, name='addPost'),
    path('editPost/<int:pk>/', views.editPost, name='editPost'),
    path('posts/<int:pk>/', views.readPost, name='readPost'),
    path('editComment/<int:pk>/', views.editComment, name='editComment'),
    path('addReply/<int:pkC>/', views.editReply, name='addReply'),
    path('editReply/<int:pkC>/<int:pkR>/', views.editReply, name='editReply'),
    path('addReplyReply//<int:pkR>/', views.editReply, name='addReplyReply'),
    path('profil/<str:username>/', views.profil, name='profil'),
    path('profil/<str:username>/warnaRandom/', views.warnaRandom, name='warnaRandom'),
    path('confirmDeletePost/<int:pk>/', views.confirmDeletePost, name='confirmDeletePost'),
    path('deletePost/<int:pk>/', views.deletePost, name='deletePost'),
    path('confirmDeleteComment/<int:pk>/', views.confirmDeleteComment, name='confirmDeleteComment'),
    path('deleteComment/<int:pk>/', views.deleteComment, name='deleteComment'),
    path('confirmDeleteReply/<int:pk>/', views.confirmDeleteReply, name='confirmDeleteReply'),
    path('deleteReply/<int:pk>/', views.deleteReply, name='deleteReply'),
    path('loadMore/', views.loadMore),
    path('category/<str:category>/loadMore/', views.loadMore),
    path('search/', views.search),
    path('category/<str:category>/search/', views.search),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about'),
]

tk1ppwb12/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('userAuth/', include('userAuth.urls')),
    path('userAuth/', include('django.contrib.auth.urls')),
    path('forum/', include('forum.urls')),
    path('HoaxSpreader/',include('HoaxSpreader.urls')),
    path('TestPengetahuan/',include('TestPengetahuan.urls')),
    path('hoax_destroyer/', include('hoax_destroyer.urls')),
    path('TestHoax/', include('TestHoax.urls')),
]

userAuth/urls.py
from django.urls import path
from .views import *
from . import views
from django.contrib.auth import views as auth_views
from .forms import AccountLoginForm

app_name = 'userAuth'

urlpatterns = [
    path('signup/', Signup.as_view(), name='signup'),
    path('login/', auth_views.LoginView.as_view(authentication_form=AccountLoginForm), name='login'),
]

forum/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from datetime import datetime, date

KATEGORI = (
    ('', '*Pilih Kategori Diskusi*'),
    ('umum', 'Diskusi Umum'),
    ('info', 'Informasi Covid-19'),
    ('hd', 'Hoax Destroyer'),
    ('hs', 'Hoax Spreader'),
    ('th', 'Test Hoax'),
    ('tp', 'Test Pengetahuan Covid-19'),
)

class Post(models.Model):
    judul = models.CharField(max_length = 150)
    kategori = models.CharField(max_length = 25, choices = KATEGORI, default='')
    isi = models.TextField()
    penulis = models.ForeignKey(User, on_delete = models.CASCADE)
    tanggalPost = models.DateTimeField(default=timezone.now)
    warna = models.CharField(max_length = 20, null=True, blank=True)
    strings = models.TextField(null=True, blank=True)
    
class Comment(models.Model):
    isi = models.TextField()
    post = models.ForeignKey(Post, on_delete = models.CASCADE)
    penulis = models.ForeignKey(User, on_delete = models.CASCADE)
    tanggalPost = models.DateTimeField(default=timezone.now)
    jumlahReply = models.CharField(max_length = 100, null=True, blank=True)
    
class ReplyComment(models.Model):
    isi = models.TextField()
    penulis = models.ForeignKey(User, on_delete = models.CASCADE)
    komen = models.ForeignKey(Comment, on_delete = models.CASCADE)
    targetBalasan = models.ForeignKey('self', on_delete = models.CASCADE, null=True, blank=True)
    tanggalPost = models.DateTimeField(default=timezone.now)

class Color(models.Model):
    color1 = models.IntegerField()
    color2 = models.IntegerField()
    color3 = models.IntegerField()
    user = models.ForeignKey(User, on_delete = models.CASCADE)

forum/forms.py
from django import forms
from .models import Post, Comment, ReplyComment, Color
from forum.models import KATEGORI

class PostForm(forms.ModelForm):
    class Meta:
        model = Post
        fields = ["judul", "kategori", "isi"]
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_judul = {
        'type' : 'text',
        'placeholder' : 'Judul Diskusi',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    input_attrs_kategori = {
        'type' : 'text',
        'placeholder' : 'Kategori Diskusi',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    input_attrs_isi = {
        'type' : 'text',
        'placeholder' : 'Isi Diskusi',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    judul = forms.CharField(label='', required=True, max_length=150, widget=forms.TextInput(attrs=input_attrs_judul))
    kategori = forms.ChoiceField(label='', choices=KATEGORI, widget=forms.Select(attrs=input_attrs_kategori))
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_attrs_isi))

    
class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ["isi"]
        exclude = ('post', 'penulis', 'tanggalPost',)
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_isi = {
        'type' : 'text',
        'placeholder' : 'Komentar',
        'class' : 'form-control form-comment',
        'autocomplete' : 'off',
        'rows' : 2
    }
    
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_attrs_isi))

    
class ReplyCommentForm(forms.ModelForm):
    class Meta:
        model = ReplyComment
        fields = ["isi"]
        exclude = ('comment', 'penulis', 'tanggalPost',)
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_isi = {
        'type' : 'text',
        'placeholder' : 'Balas Komentar',
        'class' : 'form-control form-reply',
        'autocomplete' : 'off',
        'autofocus' : 'autofocus'
    }
    
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_attrs_isi))
    
class ColorForm(forms.ModelForm):
    class Meta:
        model = Color
        fields = ["color1", "color2", "color3"]
        exclude = ('user',)
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_color = {
        'type' : 'number',
        'placeholder' : 'Angka 0 sampai 255',
        'class' : 'form-control form-rgb',
        'autocomplete' : 'off'
    }
    
    color1 = forms.IntegerField(label='Red', required=True, widget=forms.TextInput(attrs=input_attrs_color))
    color2 = forms.IntegerField(label='Green', required=True, widget=forms.TextInput(attrs=input_attrs_color))
    color3 = forms.IntegerField(label='Blue', required=True, widget=forms.TextInput(attrs=input_attrs_color))
    

forum/views.py
from django.shortcuts import get_object_or_404, redirect, render, reverse
from django.http import HttpResponseForbidden, HttpResponseNotFound, HttpResponseRedirect, HttpResponse
from .forms import PostForm, CommentForm, ReplyCommentForm, ColorForm
from .models import Post, Comment, ReplyComment, Color
import random
from django.contrib.auth.models import User
from django.core import serializers

def forum(request, category=None):
    #warna
    if request.user.is_authenticated:
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
    else:
        warnaUser = None
    semuaWarna = Color.objects.all()
    
    if category == 'user' and request.user.is_authenticated:
        diskusi = Post.objects.filter(penulis = request.user).order_by('-tanggalPost')[:10]
    elif category != 'semuaDiskusi' and category:
        diskusi = Post.objects.filter(kategori = category).order_by('-tanggalPost')[:10]
    else:
        diskusi = Post.objects.all().order_by('-tanggalPost')[:10]
        
    if (category == 'user' and not request.user.is_authenticated) or (category != 'semuaDiskusi' and category != 'umum' and category != 'info' and category != 'hd' and category != 'hs' and category != 'th' and category != 'tp' and category != 'user' and category != None):
        return HttpResponseNotFound()
    if category:
        context = {'category' : category, 'diskusi' : diskusi, 'semuaWarna' : semuaWarna, 'warnaUser' : warnaUser}
        return render(request, 'forum/forum.html', context)
        
    context = {'category' : 'semuaDiskusi', 'diskusi' : diskusi, 'semuaWarna' : semuaWarna, 'warnaUser' : warnaUser}
    return render(request, 'forum/forum.html', context)


def editPost(request, pk=None):
    
    if request.user.is_authenticated:
    
        if pk:
            post = get_object_or_404(Post, pk=pk)
            if post.penulis != request.user:
                return HttpResponseForbidden()
        else:
            post = Post(penulis = request.user)

        form = PostForm(request.POST or None, instance = post)
        if request.POST and form.is_valid():
            form.save()
            
            warna = Color.objects.filter(user = request.user)
            if not warna:
                warna = Color(
                    color1 = random.randint(0, 255),
                    color2 = random.randint(0, 255),
                    color3 = random.randint(0, 255),
                    user = request.user
                )
                warna.save()
            
            temp = Post.objects.last()
            tempWarna = Color.objects.get(user = temp.penulis)
            temp2Warna = str(tempWarna.color1) + " " + str(tempWarna.color2) + " " + str(tempWarna.color3)
            temp.warna = temp2Warna
            
            tempStrings = temp.judul + " " + temp.penulis.username + " " + temp.isi
            temp.strings = tempStrings
            temp.save()
            
            return redirect('forum:readPost', post.pk)
        
        #warna
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
        return render(request, 'forum/editPost.html', {
            'form': form,
            'warnaUser' : warnaUser
        })
    
    return render(request, 'forum/notLoggedIn.html', {'message':'"Mulai Diskusi"'})
   
   
def readPost(request, pk):
    diskusi = get_object_or_404(Post, pk = pk)
    komen = Comment.objects.filter(post = diskusi).order_by('tanggalPost')
    reply = ReplyComment.objects.all().order_by('tanggalPost')
        
    #pick random Posts
    if request.user.is_authenticated:
        postWithoutUser = Post.objects.exclude(penulis = request.user).exclude(kategori = diskusi.kategori).order_by('-tanggalPost')
    else:
        postWithoutUser = Post.objects.exclude(kategori = diskusi.kategori).order_by('-tanggalPost')
    if len(postWithoutUser) > 3:
        random_pk = random.randint(0, len(postWithoutUser)-3)
    else:
        random_pk = 0
    randomDiskusi = postWithoutUser[random_pk:random_pk+3]
        
    #pick latest posts in category
    if request.user.is_authenticated:
        postWithoutUser = Post.objects.filter(kategori = diskusi.kategori).exclude(penulis = request.user).exclude(judul = diskusi.judul).order_by('-tanggalPost')
    else:
        postWithoutUser = Post.objects.filter(kategori = diskusi.kategori).exclude(judul = diskusi.judul).order_by('-tanggalPost')
    diskusiLatestInCategory = postWithoutUser[0:3]
        
    #Form Comment
    if request.user.is_authenticated:
        komenForForm = Comment(penulis = request.user, post = diskusi)
        form = CommentForm(request.POST or None, instance = komenForForm)
        if request.POST and form.is_valid():
            form.save()
            
            kom = Comment.objects.last()
            kom.jumlahReply = str(0);
            kom.save()
            
            return HttpResponseRedirect(request.path_info)
    else:
        form = None
        
    #warna
    if request.user.is_authenticated:
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
    else:
        warnaUser = None
    semuaWarna = Color.objects.all()
    return render(request, 'forum/readPost.html', {
        'diskusi' : diskusi, 
        'komen' : komen, 
        'reply' : reply, 
        'form' : form, 
        'randomDiskusi' : randomDiskusi, 
        'diskusiLatestInCategory' : diskusiLatestInCategory, 
        'semuaWarna' : semuaWarna, 
        'warnaUser' : warnaUser
        })
    

def editComment(request, pk):
    if request.user.is_authenticated:
    
        komen = get_object_or_404(Comment, pk=pk)
        if komen.penulis != request.user:
            return HttpResponseForbidden()
                
        form = CommentForm(request.POST or None, instance = komen)
        if request.POST and form.is_valid():
            form.save()
            return redirect('forum:readPost', komen.post.pk)
        
        type = 'edit'
        
        #warna
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
        semuaWarna = Color.objects.all()
        return render(request, 'forum/editComment.html', {
            'form': form,
            'diskusi' : komen.post,
            'komen' : komen,
            'type' : type,
            'semuaWarna' : semuaWarna,
            'warnaUser' : warnaUser
        })
    return render(request, 'forum/notLoggedIn.html', {'message':'buat atau ubah komentar'})
    

def editReply(request, pkC = None, pkR = None):
    if request.user.is_authenticated:
        target = None
        
        if not pkC and pkR:
            target = get_object_or_404(ReplyComment, pk=pkR)
            komen = target.komen
        else:
            komen = get_object_or_404(Comment, pk=pkC)
    
        if pkC and pkR:
            reply = get_object_or_404(ReplyComment, pk=pkR)
            target = reply
            type = 'edit'
            if reply.penulis != request.user:
                return HttpResponseForbidden()
        elif not pkC and pkR:
            reply = ReplyComment(penulis = request.user, komen = komen, targetBalasan = target, isi = "@"+target.penulis.username+" ")
            type = 'add'
        else:
            reply = ReplyComment(penulis = request.user, komen = komen)
            type = 'add'

        form = ReplyCommentForm(request.POST or None, instance = reply)
        if request.POST and form.is_valid():
            form.save()
            if type == 'add':
                rep = ReplyComment.objects.last()
                kom = rep.komen
                komJumRep = int(kom.jumlahReply)
                kom.jumlahReply = str(komJumRep + 1)
                kom.save()
            return redirect('forum:readPost', komen.post.pk)
        
        #targetBalasan
        if target != None:
            listTarget = [target]
            while target.targetBalasan != None:
                target = target.targetBalasan
                listTarget.append(target)
            listTarget.reverse()
        else:
            listTarget = None
        
        #warna
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
        semuaWarna = Color.objects.all()
        
        context = {
            'form': form,
            'komen' : komen,
            'listTarget' : listTarget,
            'type' : type,
            'semuaWarna' : semuaWarna,
            'warnaUser' : warnaUser
        }
        return render(request, 'forum/editComment.html', context)
    
    return render(request, 'forum/notLoggedIn.html', {'message':'buat atau ubah balasan'})


def profil(request, username):
    if request.user.is_authenticated:
        warnaUser = Color.objects.filter(user = request.user)
        if warnaUser:
            warnaUser = Color.objects.get(user = request.user)
    else:
        warnaUser = None
        
    #check if user exist by username
    filterUser = User.objects.filter(username = username)
    
    if filterUser:
        user = User.objects.get(username = username)
        #check if user aldery have color or not
        filter = Color.objects.filter(user = user)
        
        diskusi = Post.objects.filter(penulis = user).order_by('-tanggalPost')
        semuaWarna = Color.objects.all()
        
        if filter:
            warna = Color.objects.get(user = user)
        
        if request.user == user:
            if not filter:
                warna = Color(user = user)
                
            form = ColorForm(request.POST or None, instance = warna)
            if request.POST and form.is_valid():
                form.save()
                

forum/templates/forum/confirmDelete.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>FunCovidInfo | Komentar</title>
<link rel="stylesheet" href="{% static 'forum/css/styles.css' %}">
{% endblock meta %}

{% block content %}
    <div class="container">
        <div class="atasbawah">
            <div class="subjudul">
                Hapus {% if diskusi %}Diskusi{% elif komen and not reply %}Komentar{% elif reply %}Balasan{% endif %} ini?
            </div>
            {% if diskusi %}
                <div class="atasbawah preview-edit-komen">
                    <div onclick="location.href='{% url 'forum:readPost' diskusi.pk %}';" {% for w in semuaWarna %}{% if w.user == diskusi.penulis %}{% if diskusi.kategori == 'umum' %}class="post umum"{% elif diskusi.kategori == 'info' %}class="post info"{% elif diskusi.kategori == 'hd' %}class="post hd"{% elif diskusi.kategori == 'hs' %}class="post hs"{% elif diskusi.kategori == 'th' %}class="post th"{% elif diskusi.kategori == 'tp' %}class="post tp"{% endif %}{% endif %}{% endfor %}>
                        <div class="kanankiri inside-post alignkanankiriatas">
                            <div class="profile-container">
                                <div class="profile" {% for w in semuaWarna %}{% if w.user == diskusi.penulis %}style="background-color: rgb({{ w.color1 }}, {{ w.color2 }}, {{ w.color3 }});"{% endif %}{% endfor %}>
                                    <div class="atasbawah center inisial">
                                        {{ diskusi.penulis.username|make_list|first|upper }}
                                    </div>
                                </div>
                            </div>
                            <div class="atasbawah alignatasbawahkiri snippet">
                                <div class="judulPost">
                                    {{ diskusi.judul|truncatechars:120 }} <br>
                                </div>
                                <span class="subJudulPost">
                                    <a href="{% url 'forum:forum2' diskusi.kategori %}" {% if diskusi.kategori == 'umum' %}class="blue"{% elif diskusi.kategori == 'info' %}class="red"{% elif diskusi.kategori == 'hd' %}class="yellow"{% elif diskusi.kategori == 'hs' %}class="purple"{% elif diskusi.kategori == 'th' %}class="green"{% elif diskusi.kategori == 'tp' %}class="black"{% endif %}>
                                        {% if diskusi.kategori == 'umum' %}(Diskusi Umum){% elif diskusi.kategori == 'info' %}(Informasi Covid-19){% elif diskusi.kategori == 'hd' %}(Hoax Destroyer){% elif diskusi.kategori == 'hs' %}(Hoax Spreader){% elif diskusi.kategori == 'th' %}(Test Hoax){% elif diskusi.kategori == 'tp' %}(Test Pengetahuan Covid-19){% endif %}
                                    </a> 
                                     oleh 
                                    <a href="{% url 'forum:profil' diskusi.penulis.username %}" class="edit"> {{ diskusi.penulis }} </a>
                                     pada {{ diskusi.tanggalPost|date:'d-M-Y H:i' }} WIB 
                                    {% if diskusi.penulis == request.user %} | 
                                        <a href="{% url 'forum:editPost' diskusi.pk %}" class="edit"> edit </a>
                                    {% endif %}
                                </span>
                                <div>
                                    {{ diskusi.isi|safe|truncatechars:220 }}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div>
                    <a href="{% url 'forum:deletePost' diskusi.pk %}" class="button1 bodyButton">Hapus Diskusi</a>
                </div>
            {% elif komen or reply %}
            <div class="one-komen-container preview-edit-komen">
                <div class="komen" {% if type == 'edit' and diskusi %}style="background:rgb(83, 144, 217, 0.2);"{% endif %}>
                    <div class="kanankiri inside-post-komen alignkanankiriatas">
                        <div class="profile-container-komen">
                            <div class="profile-komen" {% for w in semuaWarna %}{% if w.user == komen.penulis %}style="background-color: rgb({{ w.color1 }}, {{ w.color2 }}, {{ w.color3 }});"{% endif %}{% endfor %}>
                                <div class="atasbawah center inisial-komen">
                                    {{ komen.penulis|make_list|first|upper }}
                                </div>
                            </div>
                        </div>
                        <div class="atasbawah alignatasbawahkiri snippet-komen">
                            <div class="kanankiri headerKomen">
                                <div class="judulKomen">
                                    {{ komen.penulis }}
                                </div>
                                <span class="subJudulKomen">
                                    {{ komen.tanggalPost|date:'d M Y H:i' }} WIB
                                    {% if komen.penulis == request.user %} | 
                                        <a href="{% url 'forum:editComment' komen.pk %}" class="edit"> edit </a>
                                    {% endif %}
                                </span>
                            </div>
                            <div class="isiKomen">
                                {{ komen.isi|safe|linebreaks }}
                            </div>
                        </div>
                    </div>
                </div>
                <div class="reply-container">
                {% if listTarget %}
                    {% for t in listTarget %}
                        <div class="reply" {% if t == listTarget|last %}style="background:rgb(83, 144, 217, 0.2);"{% endif %}>
                            <div class="kanankiri inside-post-komen alignkanankiriatas">
                                <div class="profile-container-komen">
                                    <div class="profile-komen" {% for w in semuaWarna %}{% if w.user == t.penulis %}style="background-color: rgb({{ w.color1 }}, {{ w.color2 }}, {{ w.color3 }});"{% endif %}{% endfor %}>
                                        <div class="atasbawah center inisial-komen">
                                            {{ t.penulis|make_list|first|upper }}
                                        </div>
                                    </div>
                                </div>
                                <div class="atasbawah alignatasbawahkiri snippet-komen">
                                    <div class="kanankiri headerKomen">
                                        <div class="judulKomen">
                                            {{ t.penulis }}
                                        </div>
                                        <span class="subJudulKomen">
                                            {{ t.tanggalPost|date:'d M Y H:i' }} WIB
                                            {% if t.penulis == request.user %} | 
                                                <a href="{% url 'forum:editReply' t.komen.pk t.pk %}" class="edit"> edit </a>
                                            {% endif %}
                                        </span>
                                    </div>
                                    <div class="isiKomen">
                                        {{ t.isi|safe|linebreaks }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                {% endif %}
                </div>
            {% endif %}
            </div>
            {% if listTarget %}
                <div>
                    <a href="{% url 'forum:deleteReply' reply.pk %}" class="button1 bodyButton">Hapus Balasan</a>
                </div>
            {% elif not listTarget and not diskusi %}
                <div>
                    <a href="{% url 'forum:deleteComment' komen.pk %}" class="button1 bodyButton">Hapus Komentar</a>
                </div>
            {% endif %}
        </div>
    </div>
{% endblock content %}

forum/templates/forum/profil.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>FunCovidInfo | {{ userInProfil.username }}</title>
<link rel="stylesheet" href="{% static 'forum/css/styles.css' %}">
{% endblock meta %}

{% block content %}

    <div class="container">
        <div id="profil">
            <div class="atasbawah">
                <p class="judul">
                    Profil
                </p>
                <p class="subjudul">
                    Username : {{ userInProfil.username }}
                </p>
                
                <div class="profile-container">
                    <div class="profile" id="profileInProfil" {% if warna %}style="background-color: rgb({{ warna.color1 }}, {{ warna.color2 }}, {{ warna.color3 }});"{% else %}style="background-color: gray;"{% endif %}>
                        <div class="atasbawah center inisial" style="font-size: 6vw;">
                            {{ userInProfil.username|make_list|first|upper }}
                        </div>
                    </div>
                </div>
                {% if userInProfil == request.user %}
                <p style="font-size: 2vw;">
                    Ubah Warna Profil:
                </p>
                <div class="form">
                    <form method="POST">
                        {% csrf_token %}
                        {{ form.as_p }}
                        <div class="kanankiri center">
                            <button type="submit" class="button1 bodyButton">Ubah Warna</button>
                            <a href="{% url 'forum:warnaRandom' userInProfil.username %}" class="button1 bodyButton">Warna Random</a>
                        </div>
                    </form>
                </div>
                {% endif %}
                <p class="judul">
                   Diskusi oleh {{ userInProfil.username }}
                </p>
                <p class="subjudul">
                    {{ diskusi|length }} diskusi telah dimulai oleh {{ userInProfil.username }}
                </p>
                <div class="atasbawah" style="width: 100%;">
                    {% if diskusi %}
                        {% for d in diskusi %}
                            <div onclick="location.href='{% url 'forum:readPost' d.pk %}';" {% for w in semuaWarna %}{% if w.user == d.penulis %}{% if d.kategori == 'umum' %}class="post umum"{% elif d.kategori == 'info' %}class="post info"{% elif d.kategori == 'hd' %}class="post hd"{% elif d.kategori == 'hs' %}class="post hs"{% elif d.kategori == 'th' %}class="post th"{% elif d.kategori == 'tp' %}class="post tp"{% endif %}{% endif %}{% endfor %}>
                                <div class="kanankiri inside-post">
                                    <div class="profile-container">
                                        <div class="profile" {% for w in semuaWarna %}{% if w.user == d.penulis %}style="background-color: rgb({{ w.color1 }}, {{ w.color2 }}, {{ w.color3 }});"{% endif %}{% endfor %}>
                                            <div class="atasbawah center inisial">
                                                {{ userInProfil.username|make_list|first|upper }}
                                            </div>
                                        </div>
                                    </div>
                                    <div class="atasbawah alignatasbawahkiri snippet">
                                        <div class="judulPost">
                                            {{ d.judul|truncatechars:120 }} <br>
                                        </div>
                                        <span class="subJudulPost">
                                            <a href="{% url 'forum:forum2' d.kategori %}" {% if d.kategori == 'umum' %}class="blue"{% elif d.kategori == 'info' %}class="red"{% elif d.kategori == 'hd' %}class="yellow"{% elif d.kategori == 'hs' %}class="purple"{% elif d.kategori == 'th' %}class="green"{% elif d.kategori == 'tp' %}class="black"{% endif %}>
                                                {% if d.kategori == 'umum' %}(Diskusi Umum){% elif d.kategori == 'info' %}(Informasi Covid-19){% elif d.kategori == 'hd' %}(Hoax Destroyer){% elif d.kategori == 'hs' %}(Hoax Spreader){% elif d.kategori == 'th' %}(Test Hoax){% elif d.kategori == 'tp' %}(Test Pengetahuan Covid-19){% endif %}
                                            </a> 
                                             oleh 
                                            <a href="{% url 'forum:profil' d.penulis.username %}" class="edit"> {{ d.penulis }} </a>
                                             pada {{ d.tanggalPost|date:'d-M-Y H:i' }} WIB 
                                            {% if d.penulis == request.user %} | 
                                                <a href="{% url 'forum:editPost' d.pk %}" class="edit"> edit </a> | 
                                                <a href="{% url 'forum:confirmDeletePost' d.pk %}" class="edit"> delete </a>
                                            {% endif %}
                                        </span>
                                        <div>
                                            {{ d.isi|safe|truncatechars:220 }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        {% endfor %}
                    {% else %}
                        <p>{{ userInProfil.username }} belum pernah memulai diskusi</p>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
{% endblock content %}